﻿<div class="jumbotron">
    <h1>Videogame Collection</h1>
    <p class="lead">Edit and add videogames and accessories to your personal collection. Robbie Mattson Task 1</p>
</div>
<div class="row">
    <div class="col-md-4">
        <select id="users"></select>
        <ul id="videoGames"></ul>
    </div>
    <div class="col-md-4">
        <form name="formEditVideoGame" id="formEditVideoGame">
            <label>Title: <input type="text" id="Title" /></label><br />
            <label>Condition: <input type="text" id="Condition" /></label><br />
            <input type="submit" id="editVideoGame" value="Update VideoGame" /><br />
            <input type="hidden" id="hiddenVideoGameId" />
        </form>
    </div>
    <div class="col-md-4">
        <form name="formAddVideoGame" id="formAddVideoGame">
            <label>Title: <input type="text" id="TitleForAdd" /></label><br />
            <label>Condition: <input type="text" id="ConditionForAdd" /></label><br />
            <label>Platform: <select id="platformsForAdd"></select></label><br />
            <label>Owner: <select id="usersForAdd"></select></label><br />
            <input type="button" id="addVideoGame" value="Add new VideoGame" /><br />
        </form>
    </div>
</div>
<script>


    (function () {
        var vidGamesOnPlat;
        var vidGamesForUser
        var plats; //platforms
        var us; //users
        var selectedPlatId;
        var videoGamesListToUpdate = $("#videoGames");
        var userSelectToUpdate = $("#users");
        var platSelectForAdd = $("#platformsForAdd");
        var userSelectForAdd = $("#usersForAdd");
        var selectedVideoGame;
        getPlatforms(fillPlatformLists);
        getUsers(fillUserLists);
        //alert("Hello");
        getVideoGamesByPlat(1, fillVideoGamesList);
        getVideoGamesByUser(1, fillVideoGamesList);

        //$("#formAddVideoGame").off("submit");
        $("#addVideoGame").on("click", processAddVideoGame);

        function getVideoGamesByPlat(platId, callBackWhenDone) {
            vidGamesOnPlat = "loading";
            var jqxhr = $.getJSON("/api/platform/" + platId + "/videogame", function (data) {
                console.log("success");
                //alert(data);
                vidGamesOnPlat = data;
                callBackWhenDone();
            })
            
          .done(function () {
              console.log("second success");
          })
          .fail(function () {
              console.log("error");
          })
          .always(function () {
              console.log("complete");
          });
        }

        function getVideoGamesByUser(uId, callBackWhenDone) {
            vidGamesForUser = "loading";
            var jqxhr = $.getJSON("/api/user" + uId + "/videogame", function (data) {
                console.log("success");
                //alert(data);
                vidGamesForUser = data;
                callBackWhenDone();
            })
                .done(function () {
                    console.log("second success");
                })
                .fail(function () {
                    console.log("error");
                })
                .always(function () {
                    console.log("complete");
                });
        }

        function getPlatforms(callBackWhenDone) {
            //uses platform array in closure variable
            plats = "loading";

            var jqxhr = $.getJSON("/api/platform/", function (data) {
                console.log("success");
                plats = data;
                callBackWhenDone();
              })
              .done(function () {
                  console.log("second success");
              })
              .fail(function () {
                  console.log("error");
              })
              .always(function () {
                  console.log("complete");
              });
        }

        function getUsers(callBackWhenDone) {
            //uses user array in closure variable
            us = "loading";

            var jqxhr = $.getJSON("/api/user/", function (data) {
                console.log("success");
                us = data;
                callBackWhenDone();
            })
                .done(function () {
                    console.log("second success");
                })
                .fail(function () {
                    console.log("error");
                })
                .always(function () {
                    console.log("complete");
                });
        }

        function fillVideoGamesList() {
            //uses vidGamesOnPlat videogames array in closure variable
            //uses VideoGameListToUpdate list in closure variable
            videoGamesListToUpdate.html("");
            $.each(vidGamesOnPlat, function (g, game) {
                var myLi = $("<li></li>");
                myLi.attr("id", "game_" + game.VideoGameId);
                //myLi.off("click");
                myLi.on("click", selectVideoGame);
                myLi.html(game.Title);
                videoGamesListToUpdate.append(myLi);
            });
        }

        //function platformChange() {
        //    var platId = $("#platforms").find(":selected").attr("id").substring(5);
        //    alert("PLATID: " + platId);
        //    videoGamesListToUpdate = $("#videoGames");
        //    getVideoGamesByPlat(platId, fillVideoGamesList);
        //}

        function userChange() {
            var uId = $("#users").find(":selected").attr("id").substring(5);
            alert("UID: " + uId);
            videoGamesListToUpdate = $("#videoGames");
            getVideoGamesByUser(uId, fillVideoGamesList);
        }

        function selectVideoGame() {
            var vidId = this.id.substring(5);
            /*alert(vidId);*/
            selectedVideoGame = "none";
            $.each(vidGamesOnPlat, function (g, game) {
                if (game.VideoGameId == vidId) {
                    selectedVideoGame = game;
                }
            });

            if (selectedVideoGame != "none") {
                $("#Title").val(selectedVideoGame.Title);
                $("#Condition").val(selectedVideoGame.Condition);
                $("#hiddenVideoGameId").val(selectedVideoGame.VideoGameId);
                $("#formEditVideoGame").off("submit");
                $("#formEditVideoGame").on("submit", processUpdateVideoGame);
            }
        }

        function fillPlatformLists() {
            //uses platform array in closure variable
            //uses platSelectToUpdate select in closure variable
            /*platSelectToUpdate.html("");*/
            platSelectForAdd.html("");
            $.each(plats, function (g, game) {
                var myoption = $("<option></option>");
                myoption.attr("id", "game_" + game.PlatformId);
                myoption.html(game.Name);
                /*platSelectToUpdate.append(myoption);*/

                var myoptionAdd = $("<option></option>");
                myoptionAdd.attr("id", "plat_add_" + game.PlatformId);
                myoptionAdd.html(game.Name);
                platSelectForAdd.append(myoptionAdd);
            });
            //platSelectForAdd.off("change");
            //platSelectForAdd.on("change", platformChange);
        }

        function fillUserLists() {
            //uses user array in closure variable
            //uses userSelectToUpdate select in closure variable
            userSelectToUpdate.html("");
            userSelectForAdd.html("");
            $.each(us, function (u, user) {
                var myoption = $("<option></option>");
                myoption.attr("id", "user_" + user.UserId);
                myoption.html(user.FullName);
                userSelectToUpdate.append(myoption);

                var myoptionAdd = $("<option></option>");
                myoptionAdd.attr("id", "user_add_" + user.UserId);
                myoptionAdd.html(user.FullName);
                userSelectForAdd.append(myoptionAdd);
            });
            userSelectToUpdate.off("change");
            userSelectToUpdate.on("change", userChange);
        }

        function processUpdateVideoGame() {
            // uses selectedVideoGame videogame in closure variable
            var gameTitle = $("#Title").val();
            var gameCondition = $("#Condition").val();

            selectedVideoGame.Title = gameTitle;
            selectedVideoGame.Condition = gameCondition;

            $.ajax({
                contentType: 'application/json',
                url: "/api/videogame/" + selectedVideoGame.VideoGameId,
                type: 'PUT',
                data: JSON.stringify(selectedVideoGame),
                success: function (result) {
                    //alert("success?");
                },
                error: (function (xhr) {
                    console.log("error: " + xhr.status);
                    alert("failure: " + xhr.status);
                })
            });

            return false; // stop form submit
        }

        function processAddVideoGame() {
            // uses selectedVideogame videogame in closure variable
            var gameTitle = $("#TitleForAdd").val();
            var gameCondition = $("#ConditionForAdd").val();
            var vidPlatId = $("#platformsForAdd option:selected").attr("id").substring(9);
            var userId = $("#usersForAdd option:selected").attr("id").substring(9);

            alert(vidPlatId);
            alert(userId);

            var newVideoGame = new Object();
            newVideoGame.Title = gameTitle;
            newVideoGame.Condition = gameCondition;
            //alert(vidPlatId);
            //alert(JSON.stringify(newVideoGame));
            if (!isNaN(parseInt(vidPlatId))) {
                $.ajax({
                    contentType: 'application/json',
                    url: "/api/platform/" + vidPlatId + "/videogame/" + userId,
                    type: 'POST',
                    data: JSON.stringify(newVideoGame),
                    success: function (result) {
                        alert("success?");
                    },
                    error: (function (xhr) {
                        console.log("error: " + xhr.status);
                        alert("failure: " + xhr.status);
                    })
                });
            }
            else
                alert("Select a Platform");

            return false; // stop form submit
        }

    }());



</script>
